require 'faraday'
require 'json'

API_URL = "http://repasse.ufabc.edu.br/transfgov/rest/estado"

module TransfGov
  class Estado
    attr_reader :id, :sigla, :regiao, :nome

    def initialize(attributes)
      @id = attributes["id"] 
      @sigla = attributes["sigla"]
      @regiao = attributes["regiao"]
      @nome = attributes["nome"]
    end

    def self.find(id)
      sigla = id.is_a?(Symbol) ? id.to_s.upcase : id.upcase
      response = Faraday.get("#{API_URL}/#{sigla}")
      attributes = JSON.parse(response.body)
      new(attributes)
    end

    def self.all
      response = Faraday.get("#{API_URL}")
      estados = JSON.parse(response.body)
      estados.map { |attributes| new(attributes) }
    end

  end
end